#ifndef LmbfGui_H
#define LmbfGui_H

// cumbia
#include <qulogimpl.h>
#include <cucontrolsfactorypool.h>
class CumbiaPool;
class QuPlotCurve;
// cumbia

#include <QWidget>
#include <qwt_compat.h>
#include <qwt_scale_draw.h>
#include <quwatcher.h>
#include <tango.h>

class fftScaleDraw : public QwtScaleDraw
{
    QVector<QString> fftLabels;
public:
    fftScaleDraw();
    ~fftScaleDraw();
    void set_num_turns(double);
    virtual QwtText label(double v) const;
private:
    double num_turns;
};

namespace Ui {
class LmbfGui;
}




class LmbfGui : public QWidget
{
    Q_OBJECT

public:
    explicit LmbfGui(CumbiaPool *cu_p, QWidget *parent = 0);
    ~LmbfGui();
public slots:
    void update_num_turns(double);
    void update_sevr(QString);

private slots:
    void setCurveSticksStyle(QuPlotCurve *);
    void setFillArea(QuPlotCurve *c);
    void scale_change();
    
protected:
    QPalette normalpalette;
    QPalette alarmpalette;

private:
    Ui::LmbfGui *ui;
    fftScaleDraw *fftScale;
    QuWatcher *turns_reader;
    QuWatcher *sevr_reader;
    double num_turns;

    CumbiaPool *cu_pool;
    QuLogImpl m_log_impl;
    CuControlsFactoryPool m_ctrl_factory_pool;

};

#endif // LmbfGui_H

